/**
   @author	Yasutaka SHINDOH
 */

#include <stdio.h>

#define	BUFFER_LENGTH	1024
#define	IN_COMMAND	"gzip -cd %s"
#define	OUT_COMMAND	"gzip -c9 > %s"
/* #define	INPUT_MODE	"rb" */
/* #define	OUTPUT_MODE	"wb" */

int main(int count, char** arguments)
{
	char command[BUFFER_LENGTH];
	const char* in_file = NULL;
	const char* out_file = NULL;
	FILE* in_pipe = NULL;
	FILE* out_pipe = NULL;
	int letter;

	if (count != 3) goto error;

	in_file = arguments[1];
	out_file = arguments[2];

	snprintf(command, BUFFER_LENGTH, IN_COMMAND, in_file);
	in_pipe = popen(command, INPUT_MODE);
	if (!in_file) goto error;

	snprintf(command, BUFFER_LENGTH, OUT_COMMAND, out_file);
	out_pipe = popen(command, OUTPUT_MODE);
	if (!out_file) goto error;

	for (;;) {
		letter = fgetc(in_pipe);
		if (letter == EOF) break;
		letter = fputc(letter, out_pipe);
		if (letter == EOF) goto error;
	}

	pclose(in_pipe);
	pclose(out_pipe);

	return 0;

error:

	if (in_pipe) pclose(in_pipe);
	if (out_pipe) pclose(out_pipe);

	return 1;
}
